import { IWeAppData, IPlugin } from '@cloudbase/lowcode-generator/lib/weapps-core';
import { ICDN_ENDPOINTS_COFIG } from '../config';
import { IBuildContext } from './BuildContext';
import { BuildType } from '../types/common';
import { IPlatformApp } from '@cloudbase/cals';
import { IBuildWedaApp } from '../core';
export declare function generateWxMp({ buildContext, weapps, calses, plugins, deployOptions, options, buildTypeList, ignoreInstall, cdnEndpoints, }: {
    buildContext: IBuildContext;
    weapps: IWeAppData[];
    calses: IPlatformApp[];
    plugins: IPlugin[];
    deployOptions: Required<IBuildWedaApp>['deployOptions'];
    options: {
        mpAppId: string;
        resourceAppId?: string;
        isCrossAccount: boolean;
    };
    buildTypeList: BuildType[];
    ignoreInstall: boolean;
    cdnEndpoints?: ICDN_ENDPOINTS_COFIG;
}): Promise<{
    miniprogramRoot: string;
}>;
export declare function generateConfig(data: {
    domain?: string;
    isPrivateMode?: boolean;
    endpointType?: IBuildContext['endpointType'] | '';
}, root: string): Promise<void>;
export declare function writeLowCodeFiles(ctx: IBuildContext, appData: IWeAppData, outDir: string): Promise<void>;
